=== GraphBLAS/@GrB/private/Makefile ===
#-------------------------------------------------------------------------------
# GraphBLAS/GraphBLAS/private/Makefile
#-------------------------------------------------------------------------------

# SuiteSparse:GraphBLAS, Timothy A. Davis, (c) 2017-2018, All Rights Reserved.
# SPDX-License-Identifier: Apache-2.0

#-------------------------------------------------------------------------------

# This is just here for 'make clean', to remove compiled codes.

default: mexfuncs

clean:
	- $(RM) -rf *.o *.mex*

purge: clean

distclean: clean
