=== debian/changelog ===
suitesparse-graphblas (7.4.0+dfsg-2) unstable; urgency=medium

  * Team upload.

  [ Dandan Zhang ]
  * Fix build on loongarch64 (Closes: #1100111)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 12 Mar 2025 08:54:10 +0100

suitesparse-graphblas (7.4.0+dfsg-1) unstable; urgency=medium

  * New upstream release
  * Update symbol file

 -- Vincent Prat <vivi@debian.org>  Wed, 28 Dec 2022 23:10:42 +0100
