=== debian/watch ===
version=4
opts=dversionmangle=s/\+dfsg\d*$//,\
repacksuffix=+dfsg,\
filenamemangle=s/.+\/v?(\d[.\d]*)\.tar\.gz/suitesparse-graphblas-$1\.tar\.gz/ \
     https://github.com/DrTimothyAldenDavis/GraphBLAS/tags \
     .*/v?(\d[.\d]*)\.tar\.gz
